% Similarity (dice-overlap coefficient) in the negative-connectivity profile between TASK and
% REST-noGSR
% Meiling Li, April, 2017

clear,clc
addpath(genpath ('/zfs/musc/Xiaoxuan/Software/workbench'));
addpath(genpath('/zfs/musc/Xiaoxuan/Scripts/CIFTIMatlabReaderWriter_Xpeng'));

% set path
RestPath = '/zfs/musc/Meiling/HCP/NegCount/REST_noGSR';
TaskPath = '/zfs/musc/Meiling/HCP/NegCount/TASK';
OutPath = '/zfs/musc/Meiling/HCP/NegCount';
SIDs = textread('/zfs/musc/Meiling/HCP/Lists/HCP_680.txt','%s');



% threshold to define NEGATIVE connectivity
rth = 0;

DiceMap = zeros(59412,1);
DiceValue = zeros(length(SIDs),1);
for s = 1:length(SIDs)
    s
    sub = SIDs{s};
    
    %%  REST-noGSR, load FC profile
    load([RestPath '/' sub '_connectProfile.mat']) % ConnectProfile
     
    % Find negative connecitivity mask, set negative FC as "1"
    ConnectProfile(ConnectProfile>rth) = 0;
    ConnectProfile(ConnectProfile<rth) = 1;
    NegcountMap_s1 = ConnectProfile;
    
    
    %% task co-activation
    load([TaskPath '/' sub '_connectProfile.mat']);
    ConnectProfile(ConnectProfile>rth) = 0;
    ConnectProfile(ConnectProfile<rth) = 1;
    NegcountMap_s2 = ConnectProfile;
    
    
    %% Dice-overlap
    NegcountMap = NegcountMap_s1+NegcountMap_s2;
    NegMask = NegcountMap;
 
    NegcountMap(NegcountMap<2) = 0;
    NegcountMap(NegcountMap==2) = 1;
    DiceMap_s = 2*sum(NegcountMap,2)./sum(NegMask,2);
    
    
    
    DiceMap = DiceMap+DiceMap_s;
    DiceValue(s) = nanmean(DiceMap_s);
end

%% average dice map
m_DiceMap = DiceMap./s;
cifti_template = open_wbfile('/zfs/musc/Xiaoxuan/Scripts/CIFTIMatlabReaderWriter_Xpeng/example.dscalar.nii');
cifti_template.cdata = m_DiceMap;
ciftisave(cifti_template,[OutPath '/Dice_Negcount_Rest_noGSR_Task_th' num2str(rth) '.dscalar.nii']);
save([OutPath '/Dice_Negcount_Rest_noGSR_Task_th' num2str(rth) '_allsubs.mat'],'DiceValue');
